import sys
import random
import datetime
import traceback
from datetime import timedelta

from ardi.driver import histdriverbase
import MySQLdb

def fixdate(dt):
	ps = dt.find('.')
	if ps > -1:
		return dt[0:ps]
	return dt

class ardihistdriver:
    def __init__(self):        
        self.port = 0
        self.db = None        
        self.host = ""
        self.database = ""
        self.username = ""
        self.password = ""
        self.query = ""
        self.stamp = ""
        self.table = ""
        self.lookup = ""
        self.value = ""
        self.filter = ""
        self.lookuptable = {}
        self.retry = False

    def SetAddress(self, addr):
        self.connected = False
        bits = addr.split(":")
        filter = ""

        #print "Raw Address"

        if len(bits) >= 6:
            self.host = bits[0]
            self.port = bits[1]
            self.database = bits[2]
            self.username = bits[3]
            self.password = bits[4]
            self.table = bits[5]
            self.lookup = bits[6]
            self.stamp = bits[7]
            self.value = bits[8]
        if len(bits) > 9:
            filter = bits[9]

    def Connect(self):
        try:
        	print "Connecting!"
        	self.db = MySQLdb.connect(self.host,self.username,self.password,self.database)
        	self.connected = True        	
        	
        	return True
        except:
        	return False			

    def Disconnect(self):
        try:			
        	self.con.close()
        except:
        	pass	

    def Query(self, points, start,end,function,grain,first):
		#print "Performing '" + function + "' query on " + str(points) + " between " + start + " and " + end 								
		sd = datetime.datetime.strptime( start, "%Y-%m-%d %H:%M:%S" )
		ed = datetime.datetime.strptime( end, "%Y-%m-%d %H:%M:%S" )

		#OK - fabricate an SQL query...			
		func = "AVG"
		if function == "min":
			func = "MIN"
		if function == "max":
			func = "MAX"

		x = 0
		lookuptable = {}
		for p in points:			
			lookuptable[str(p)] = x
			x = x + 1

		out = ""

		try:
			self.db.commit()
		except:
			pass

		#print points

		if function == "raw":			
			if first == 1:
				topoffquery = "SELECT " + self.stamp + ", " + self.lookup + "," + self.value +" FROM ( SELECT * "		
				topoffquery += "FROM " + self.table + " WHERE " + self.stamp + " <= '" + str(sd) + "' AND " + self.lookup + " IN ("

				x=0
				for p in points:
					if x > 0:
						topoffquery += ","
					topoffquery += "'" + p + "'"
					x = x + 1

				topoffquery += ") ORDER BY " + self.stamp + " DESC) AS t1 GROUP BY " + self.lookup
				
				csr = self.db.cursor()
				csr.execute(topoffquery);
				
				#This is the first fetch of raw data. As such, I'm going to need the PREVIOUS points for interpolation...

				for row in csr:
					out += str(lookuptable[str(row[1])]) + "," + str(row[0]) + "," + str(row[2]) + "\r\n"

				csr.close()
		
		self.query = "SELECT " + self.stamp + "," + self.lookup + "," + self.value + " FROM " + self.table + " WHERE "
		if grain != 0:
			self.query = "SELECT DATE_ADD('" + str(sd) + "',INTERVAL (CEIL(TIMESTAMPDIFF(SECOND,'" + str(sd) + "'," + self.stamp + ") / " + str(grain) + ") * " + str(grain) + ") SECOND) as ostamp, " + self.lookup + " as lookup,"+ func + "(" + self.value + ") as value" + " FROM " + self.table + " WHERE "
			
		if self.filter != "":
			self.query += "( " + self.filter + " ) AND "
			
		self.query += "( " + self.stamp + " >= '" + str(sd) + "' AND " + self.stamp + " <= '" + str(ed) + "' )"

		#Filter for point list...
		self.query += " AND " + self.lookup + " IN ( "
		x = 0		
		for p in points:
			if x > 0:
				self.query += ","
			self.query += "'" + p + "'"			
			x = x + 1

		#print lookuptable

		self.query += " )"
		if grain != 0:
			self.query += " GROUP BY ostamp, lookup ORDER BY ostamp,lookup"
		else:
			self.query += " ORDER BY " + self.stamp + " ASC"

		#print "Submitting Query: " + self.query
		
		try:			
			csr = self.db.cursor()			

			csr.execute(self.query)		
			for row in csr:
				out += str(lookuptable[str(row[1])]) + "," + str(row[0]) + "," + str(row[2]) + "\r\n"

			csr.close()
		except:
			if self.retry == false:
				self.retry = True
				try:
					self.db = MySQLdb.connect(self.host,self.username,self.password,self.database)
					self.connected = True
					return self.query(points, start,end,function,grain,first)
				except:
					pass
			return ""
		
		topoffquery = "SELECT " + self.stamp + ", " + self.lookup + "," + self.value +" FROM ( SELECT * "		
		topoffquery += "FROM " + self.table + " WHERE " + self.stamp + " >= '" + str(ed) + "' AND " + self.lookup + " IN ("

		x=0
		for p in points:
			if x > 0:
				topoffquery += ","
			topoffquery += "'" + p + "'"
			x = x + 1

		topoffquery += ") ORDER BY " + self.stamp + " ASC) AS t1 GROUP BY " + self.lookup

		try:	
			csr = self.db.cursor()
			csr.execute(topoffquery);
		
			#OK - same deal, but this time get the NEXT row value from each...

			for row in csr:
				out += str(lookuptable[str(row[1])]) + "," + str(row[0]) + "," + str(row[2]) + "\r\n"

			csr.close()
		except:
			pass

		try:
			self.db.commit()
		except:
			pass

		#print out

		self.retry = False

		return out.encode('ascii')
		            
class driverfactory:
    def createinstance(self):
        return ardihistdriver()
            
if __name__ == "__main__":
    sdf = driverfactory()
    base = histdriverbase.historian()
    base.start(sdf)