import sys
import time

from ardi.driver import drivercore,driverbase
import MySQLdb

#import mysql.connector
#from mysql.connector import errorcode
#import mysqldb

class sqladdress:
    def __init__(self, addr):
        self.conditionvalue = ""        
                            
class ardimysqldriver:
    def __init__(self):
        self.connected = False
        self.polling = True
        self.pollinterval = 10
        self.subscription = ''
        self.port = 0
        self.db = None        
        self.host = ""
        self.database = ""
        self.username = ""
        self.password = ""
        self.query = ""
        self.lookuptable = {}

    def SetAddress(self, addr):
        self.connected = False
        if addr is None:
            return;
        bits = addr.split(":")
        filter = ""

        #print "Raw Address"

        if len(bits) >= 6:
            self.host = bits[0]
            self.port = bits[1]
            self.database = bits[2]
            self.username = bits[3]
            self.password = bits[4]
            table = bits[5]
            lookup = bits[6]
            stamp = bits[7]
            value = bits[8]
        if len(bits) > 9:
            filter = bits[9]

        if stamp == "":
            self.query = "SELECT " + lookup + "," + value + " FROM " + table
            if filter != "":
                self.query += " WHERE ( " + filter + " )"            
        else:                        
            self.query = "SELECT * FROM ( SELECT " + lookup + "," + value + " FROM " + table
            if filter != "":
                self.query += " WHERE ( " + filter + " ) "
            self.query += " ORDER BY " + stamp + " DESC ) as t1 GROUP BY " + lookup;

        #self.core.logger.warning("Using Query: " + self.query);   
        #print "Final Query = " + self.query
    
    def Connect(self):
        try:            
            self.db = MySQLdb.connect(self.host,self.username,self.password,self.database)
            self.connected = True        
        except StandardError as err:
            self.core.logger.error(err[1])
            #print err
            return False
        except:            
            return False
        return True

    def Optimise(self):        
        self.lookuptable = {}
        x=-1
        for itm in self.core.pointlist:
            x = x+1
            self.lookuptable[itm.address] = x     

    def Disconnect(self):
        self.connected = False
        self.db.close()
        
    def Poll(self):
        try:
            csr = self.db.cursor()
            timing = time.time()
            #print "Querying: " + self.query          
            csr.execute(self.query)                
            for row in csr:
                if row[0] in self.lookuptable:                    
                    self.core.UpdateData(self.core.pointlist[self.lookuptable[row[0]]].code,str(row[1]))
                    #print self.core.pointlist[self.lookuptable[row[0]]].code + " = " + str(row[1])

            #print "Query Time: " + str(time.time() - timing)
            self.db.commit()                     
            csr.close()        
        except StandardError as err:
            try:
                if (str(err[1]) == "MySQL server has gone away") or (str(err[1]) == ""):
                    self.core.logger.error('Data Connection Lost')
                    try:
                        self.db.close()
                    except:
                        pass
                    self.connected = False
                    return
                self.core.logger.error('Query Failed: ' + err[1] + " in " + self.query)
            except:
                self.core.logger.error('Failure')

class driverfactory:
    def createinstance(self):
        return ardimysqldriver()
            
if __name__ == "__main__":
    sdf = driverfactory()
    base = driverbase.ardidriver()
    base.start(sdf)
